mrrl

Minimal Reliable Reproducible Linux
git clone https://ccx.te2000.cz/git/mrrl
Log | Files | Refs | Submodules | README

ocaml-findlib (6793B)


      1 #!/usr/bin/env pthbs-build
      2 #+busybox.7f0e4d86f69de7624b0468018b9933c3e3c1757c8ff73938746c292196f916dd
      3 #+busybox-bzip2.52d2053dff44277d3c6f700eec6807d2c64c226e0f1bf589372ff5ff625be40e
      4 #+busybox-gzip.085fc42ce36be284c89a9dec6889cca59dedd07b9ba93a21d3198c4adcac5840
      5 #+busybox-lzop.bccd8f86de85a74d466d34f802ab1ea355f0a9d9886bdfa4d7bb4a785d695be6
      6 #+busybox-unzip.237a4ec36283b7fbdb85df583c7c77c0aaf70d335b1cbae09a40a9bb4b6c82bb
      7 #+busybox-xz.db25ed2ffbfc91e7b5cff54faf2e80de59ab5b15167c2c5bb338fa1ee62de122
      8 #+busybox-cpio.307e9495bcd9b79fd9559882115d55d22c5b687e08886e696f1e53d8db7eebcd
      9 #+busybox-dpkg.3aec8347093bb5b774a0c25795cdf9e624268a3b04cc48e867d74e4e06461db7
     10 #+busybox-rpm.8435251ea7058aea0cbcd41478b144b1a15c5aa121509af887847c0ef45bf5aa
     11 #+busybox-tar.c77139157bce13db8820740b756572c22e29cfbd8bb8c2a3b22b465b70e2eae9
     12 #+busybox-ed.4ac872215d7b9c8096c4cfd508434fbd2e825aebd9a9ea8589a0033b8e50aac2
     13 #+busybox-sed.14269a860b3706f7122b827818365fecaa0e62ce5bc3273e89948685c0953f2d
     14 #+busybox-vi.7e41b306c9c47aaaa281aa8347b9fa6dca260788fd73f53a7ba9260b315627ee
     15 #+busybox-xxd.9df3407fd75b89cb640d65870298eaba77327d6e387d25d8ce1ebab01cb47857
     16 #+busybox-process-extra.65afeaded3cb8fdeea327262f28f08e50f18d51a2b456ea97b293d200c7f558e
     17 #+busybox-procps.e5dc609521d29d8aec8253147269314439131c088a6beeacc172fc07594c4a37
     18 #+busybox-psmisc.7d760b69f45bb1b8d458f2f408b9cb3a42e919e8022f0508c440a5fd20ebb66f
     19 #+busybox-ash.fd5d266905d40248735e0e2e1ae22165b6f0d42c0bacb652660f69f39c1ee71e
     20 #+busybox-bc.6f2fe17efab2237c3036eba1c37d432d696d1b5dba130e21365016ceae0a3184
     21 #+busybox-coreutils.7e581faa6901f832a2a022d72b2858c3091f47afc80a4a463adb2f2a68f1843d
     22 #+busybox-coreutils-extra.5ab183b839676b0780a9a83d75cc345a06221fa34627c44aa3732c4a5a47f9b9
     23 #+busybox-daemontools.bcea69c867a61fe1d49d2f6a27e406959c484ed20d54fd7c0341828d3cdbd428
     24 #+busybox-grep.ac20e6a4295eb7fb0a09d700e10e5fe55e2009d2858e0a1525e461d4914e820b
     25 #+busybox-misc.7f0588b97809fac8061c489b686424de1a7dd17d8eb3431aae56513c7288f1e7
     26 #+busybox-sh.288f0583edc783a176bbbc59a3e854b186258ba2605291377a545cc3191c3d52
     27 #+busybox-util-linux-unpriv.5a286246aa7204f7fa8c9a247f1c93c751979690a65200030f29e255645c1eae
     28 #+busybox-findutils.207f73a9f41a8f9e279072e920cbf0c38ba6516734fa3cf2c1faf55565613487
     29 #+nawk.84c186be0a6d09a951a8c6a5377d16b0ba0a9e476e6b554c0c832d6407ebb5b2
     30 #+busybox-diffutils.895f7a6bf6d00136038d8bafa91a6fb1e7027ce5a32e1e3b64a9119fe69ef19a
     31 #+musl-cross-make.19d51dec5328ccacd41d47d7f24e33bac084aebefb839cb3fecb6573577b831a
     32 #+gnu-make.17b0037e8a3f24180cb7bb9ddb488039d540ba905aecca0315de313adfbae81c
     33 #+m4.615d99c28c6a4c9a2fab9b75c3ae68b6adf51a7afc4b03482077a284888aedb4
     34 #+netbsd-curses.c0684f88ec90e091f88a4712cede16b62997b00ae0fbf877d9f4e9f553aa4e25
     35 #+ocaml.5d68a619356fa3da8a61022cde7b7b58e6d4e05bd0cad320650fe78e2359e764
     36 #+ocamlbuild.30e4bfbe643190132b01f96703607ced88d89cdee689d27ad26257d0d3757a6d
     37 #@untar:-z:sha256:662c910f774e9fee3a19c4e057f380581ab2fc4ee52da4761304ac9c31b8869d:.
     38 
     39 
     40 # - build script start -
     41 
     42 linker_path_mcm='/versions/musl-cross-make.19d51dec5328ccacd41d47d7f24e33bac084aebefb839cb3fecb6573577b831a/x86_64-linux-musl/lib/ld-musl-x86_64.so.1'
     43 linker_path_musl='/versions/musl.5653a8177256300ce54a6f1b8594b4c9432e458eac2800c952d348774a468519/library.so/ld-musl-x86_64.so.1'
     44 check_dynamic() {
     45 	local exe || true
     46 	exe=$pthbs_destdir'/versions'/$pthbs_package/$1
     47 	if ! test -f $exe; then
     48 		printf '%s\n' "Error: file '$1' doesn't exist!"
     49 		exit 1
     50 	fi
     51 	local interp_info || true
     52 	interp_info=$(readelf --string-dump=.interp "$exe") || exit $?
     53 	case $interp_info in
     54 		('')
     55 			printf '%s\n' "Error: '$1' is not a dynamic binary!"
     56 			exit 1
     57 			;;
     58 		(*"$linker_path_mcm")
     59 			return 0
     60 			;;
     61 		(*"$linker_path_musl")
     62 			return 0
     63 			;;
     64 		(*)
     65 			printf '%s\n' "Error: '$1' unexpected linker path!"
     66 			ls -l "$linker_path_mcm" "$linker_path_musl"
     67 			exit 1
     68 	esac
     69 }
     70 
     71 prefix=/versions/$pthbs_package
     72 dest=${pthbs_destdir%/}${prefix}
     73 cd 'findlib-1.9.8'
     74 
     75 
     76 ./configure -h || true
     77 ./configure \
     78 	-bindir "$prefix/command" \
     79 	-mandir "$prefix/man" \
     80 	-sitelib "$prefix/library.ocaml" \
     81 	-config "$prefix/config/etc/findlib.conf" \
     82 	-no-camlp4
     83  
     84 
     85 make -j1 all opt
     86 
     87 # workaround `topfind` getting installed to stdlib directory, this is not configurable
     88 stdlib="$pthbs_destdir/versions/ocaml.5d68a619356fa3da8a61022cde7b7b58e6d4e05bd0cad320650fe78e2359e764"
     89 mkdir -p "${stdlib%/*}"
     90 ln -s "$pthbs_package" "$stdlib"
     91 make install prefix="$pthbs_destdir"
     92 
     93 
     94 
     95 check_dynamic command/ocamlfind
     96 
     97 
     98 
     99 cd "$pthbs_destdir/versions/$pthbs_package"
    100 find -type d -o -print | awk -F/ '
    101 BEGIN {
    102 	x["./command/ocamlfind"]=1
    103 	x["./library.ocaml/findlib/topfind.mli"]=1
    104 	x["./library.ocaml/findlib/topfind.cmi"]=1
    105 	x["./library.ocaml/findlib/META"]=1
    106 	x["./library.ocaml/topfind"]=1
    107 	# x["./library.ocaml/bigarray/META"]=1
    108 	x["./library.ocaml/bytes/META"]=1
    109 	# x["./library.ocaml/compiler-libs/META"]=1
    110 	# x["./library.ocaml/dynlink/META"]=1
    111 	# x["./library.ocaml/ocamldoc/META"]=1
    112 	# x["./library.ocaml/stdlib/META"]=1
    113 	# x["./library.ocaml/str/META"]=1
    114 	# x["./library.ocaml/threads/META"]=1
    115 	# x["./library.ocaml/unix/META"]=1
    116 }
    117 
    118 function r1(s) {
    119 	sub("^[.]/[^/]*", ".", s)
    120 	return s
    121 }
    122 function s1(repl, s) {
    123 	sub("^[.]/[^/]*", "./"repl, s)
    124 	return s
    125 }
    126 function link(src) {
    127 	x[$0]=0
    128 	printf "%s\t%s\n", $0, src
    129 	printf "genlinks >>%s\t%s<<\n", $0, src >>"/dev/stderr"
    130 }
    131 $1!="."{exit 1}
    132 $2 == "env" { link($0); next }
    133 $2 == ".env-template" { link($0); next }
    134 
    135 $2 == "command" { link($0); next }
    136 $2 == "command" { link($0); next }
    137 $2 == "bin" { link(s1("command", $0)); next }
    138 $2 == "sbin" { link(s1("command", $0)); next }
    139 
    140 $2 == "library.so" { link($0); next }
    141 $2 == "library" { link($0); next }
    142 $2 == "lib" && $NF ~ /\.l?a$/ { link(s1("library", $0)); next }
    143 $2 == "lib" && $NF ~ /\.so(\..*)?$/ { link(s1("library.so", $0)); next }
    144 
    145 $2 == "share" && $3 == "info" { link(s1("info", r1($0))); next }
    146 $2 == "share" && $3 == "man" { link(s1("man", r1($0))); next }
    147 $2 == "share" && $3 == "doc" { link(s1("doc", r1($0))); next }
    148 
    149 $2 == "config" { link($0); next }
    150 $2 == "man" { link($0); next }
    151 $2 == "info" { link($0); next }
    152 $2 == "doc" { link($0); next }
    153 $2 == "data" { link($0); next }
    154 $2 == "include" { link($0); next }
    155 
    156 $2 == "share" && $3 ~ /^(icons|terminfo)$/ { link(r1($0)); next }
    157 
    158 $2 == "library.ocaml" { link($0); next }
    159 
    160 $2 == "keys" { link($0); next }
    161 $2 == "zsh" { link($0); next }
    162 $2 == "vimfiles" { link($0); next }
    163 $2 == "icons" { link($0); next }
    164 $2 == "terminfo" { link($0); next }
    165 
    166 
    167 { printf "genlinks ##%s## skipped\n", $0 >>"/dev/stderr" }
    168 
    169 END {
    170 	for(fname in x) { printf "DEBUG: x[\"%s\"]=\"%s\"\n", fname, x[fname] >"/dev/stderr" }
    171 	retcode = 0
    172 	for(fname in x) {
    173 		if(x[fname]) {
    174 			printf "ERROR: missing expected file \"%s\"\n", fname >"/dev/stderr"
    175 			retcode = 3
    176 		}
    177 	}
    178 	exit retcode
    179 }' >.install-links.new
    180 mv .install-links.new .install-links
    181